'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function deepFreeze(obj) {
    Object.freeze(obj);

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = Object.keys(obj)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var key = _step.value;

            var value = obj[key];

            if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
                deepFreeze(value);
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
}

var StrictError = function (_Error) {
    _inherits(StrictError, _Error);

    function StrictError(definition) {
        var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        _classCallCheck(this, StrictError);

        if (typeof definition.validate === 'function') {
            definition.validate(data);
        }

        var message = null;

        if (typeof definition.message === 'function') {
            message = definition.message(data);
        } else {
            message = definition.message;
        }

        var _this = _possibleConstructorReturn(this, (StrictError.__proto__ || Object.getPrototypeOf(StrictError)).call(this, message));

        _this.toJSON = function () {
            return {
                name: _this.name,
                message: _this.message,
                data: _this.data
            };
        };

        _this.name = definition.name;
        _this.data = data;

        deepFreeze(_this);
        return _this;
    }

    return StrictError;
}(Error);

exports.default = StrictError;